/*---------------------------------------------------------------------------*

  Copyright 2010-2011 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/
// -----------------------------------------------------------------------------
//  wksupMemory.h
//
// -----------------------------------------------------------------------------

#ifndef __WKSUP_MEMORY_H__
#define __WKSUP_MEMORY_H__

#ifdef __cplusplus
extern "C"
{
#endif



struct WKSUPheapMemSize
{
	unsigned int total;
	unsigned int free;
};

struct WKSUPmemInfo
{
	unsigned int	mTotal;
	unsigned int	mAllocated;
	unsigned int	mAvailable;
	unsigned int	mNumCurrentAllocs;
	// separate heap stuff
	WKSUPheapMemSize	mHeaps[SHIM_REAL_NUM_HEAPS];
};

struct WKSUPmemSizeInfo
{
	unsigned int graphicsMaxAllocSize;
	unsigned int wkDefaultMaxAllocSize;
	unsigned int wkCanvasMaxAllocSize;
	unsigned int wkImageMaxAllocSize;
	unsigned int wkDecodeMaxAllocSize;
	unsigned int jscDefaultMaxAllocSize;
	unsigned int jscRegisterMaxAllocSize;
};

void wksupMemorySetInfoCallbacks(void (*InfoFN)(WKSUPmemInfo *pInfo), int (*AllocSizeFN)(void *pAddr), void (*SizeInfoFN)(WKSUPmemSizeInfo*));
void wksupMemoryGetInfo(WKSUPmemInfo *pInfo);
void wksupMemoryGetSizeInfo(WKSUPmemSizeInfo *pSizeInfo);
int wksupMemoryAllocSize(void *pAddr);

#ifdef __cplusplus
}
#endif

#endif /// __WKSUP_MEMORY_H__

